<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, height=device-height, initial-scale=1, user-scalable=no">
  <meta name="description" content="API docs for the call method from the WialonSdk class, for the Dart programming language.">
  <title>call method - WialonSdk class - wialon library - Dart API</title>


  
  <link rel="preconnect" href="https://fonts.gstatic.com">
  <link href="https://fonts.googleapis.com/css2?family=Roboto+Mono:ital,wght@0,300;0,400;0,500;0,700;1,400&display=swap" rel="stylesheet">
  <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
  
  <link rel="stylesheet" href="../../static-assets/github.css?v1">
  <link rel="stylesheet" href="../../static-assets/styles.css?v1">
  <link rel="icon" href="../../static-assets/favicon.png?v1">

  
</head>


<body data-base-href="../../"
      data-using-base-href="false">

<div id="overlay-under-drawer"></div>

<header id="title">
  <button id="sidenav-left-toggle" type="button">&nbsp;</button>
  <ol class="breadcrumbs gt-separated dark hidden-xs">
    <li><a href="../../index.html">wialon</a></li>
    <li><a href="../../wialon/wialon-library.html">wialon</a></li>
    <li><a href="../../wialon/WialonSdk-class.html">WialonSdk</a></li>
    <li class="self-crumb">call method</li>
  </ol>
  <div class="self-name">call</div>
  <form class="search navbar-right" role="search">
    <input type="text" id="search-box" autocomplete="off" disabled class="form-control typeahead" placeholder="Loading search...">
  </form>
</header>

<main>


  <div id="dartdoc-main-content" class="main-content">
      <div>
<h1><span class="kind-method">call</span> method 
    <a href="https://dart.dev/null-safety" class="feature feature-null-safety" title="Supports the null safety language feature.">Null safety</a>
</h1></div>

    <section class="multi-line-signature">
      

<span class="returntype"><a href="https://api.flutter.dev/flutter/dart-async/Future-class.html">Future</a><span class="signature">&lt;<wbr><span class="type-parameter"><a href="https://api.flutter.dev/flutter/dart-core/Map-class.html">Map</a><span class="signature">&lt;<wbr><span class="type-parameter"><a href="https://api.flutter.dev/flutter/dart-core/String-class.html">String</a></span>, <span class="type-parameter">dynamic</span>&gt;</span></span>&gt;</span></span>
<span class="name ">call</span>(<wbr><ol class="parameter-list"><li><span class="parameter" id="call-param-method">{<span>required</span> <span class="type-annotation"><a href="https://api.flutter.dev/flutter/dart-core/String-class.html">String</a></span> <span class="parameter-name">method</span>, </span></li>
<li><span class="parameter" id="call-param-parameters"><span>required</span> <span class="type-annotation">dynamic</span> <span class="parameter-name">parameters</span>}</span></li>
</ol>)

      

    </section>
    
<section class="desc markdown">
  <p>Make a call to the Wialon API</p>
</section>


    
<section class="summary source-code" id="source">
  <h2><span>Implementation</span></h2>
  <pre class="language-dart"><code class="language-dart">Future&lt;Map&lt;String, dynamic&gt;&gt; call({
  &#47;&#47;&#47; [method] is the svc method declarated in the Wialon SDK documentation
  required String method,

  &#47;&#47;&#47; [parameters] is the parameters of the method, should be a Map or a List
  &#47;&#47;&#47; Refer to the documentation of the desired method to know the parameters
  required dynamic parameters,
}) async {
  dynamic arguments = {};

  if (parameters is List) {
    arguments = [...parameters];
  } else {
    arguments.addAll(parameters);
  }

  Map&lt;String, dynamic&gt; payload = {
    &#39;svc&#39;: method,
    &#39;params&#39;: jsonEncode(arguments),
    &#39;sid&#39;: sessionId ?? &quot;&quot;,
  };

  if (debug) {
    log(&#39;Method Call: ${payload[&quot;svc&quot;]}&#39;);
    log(&#39;Pararams: ${payload[&quot;params&quot;]}&#39;);
    log(&#39;SessionId: ${payload[&quot;sid&quot;]}&#39;);
  }

  try {
    http.Response response = await http.post(
      Uri.parse(baseUrl),
      body: payload,
    );
    return Map&lt;String, dynamic&gt;.from(jsonDecode(response.body));
  } catch (e) {
    throw SdkException(message: &quot;Internal error: $e&quot;);
  }
}</code></pre>
</section>


  </div> <!-- /.main-content -->

  <div id="dartdoc-sidebar-left" class="sidebar sidebar-offcanvas-left">
    <header id="header-search-sidebar" class="hidden-l">
  <form class="search-sidebar" role="search">
    <input type="text" id="search-sidebar" autocomplete="off" disabled class="form-control typeahead" placeholder="Loading search...">
  </form>
</header>

<ol class="breadcrumbs gt-separated dark hidden-l" id="sidebar-nav">
  <li><a href="../../index.html">wialon</a></li>
  <li><a href="../../wialon/wialon-library.html">wialon</a></li>
  <li><a href="../../wialon/WialonSdk-class.html">WialonSdk</a></li>
  <li class="self-crumb">call method</li>
</ol>


    <h5>WialonSdk class</h5>
    <ol>

        <li class="section-title"><a href="../../wialon/WialonSdk-class.html#constructors">Constructors</a></li>
          <li><a href="../../wialon/WialonSdk/WialonSdk.html">WialonSdk</a></li>


    <li class="section-title">
      <a href="../../wialon/WialonSdk-class.html#instance-properties">Properties</a>
    </li>
    <li><a href="../../wialon/WialonSdk/baseUrl.html">baseUrl</a></li>
    <li><a href="../../wialon/WialonSdk/debug.html">debug</a></li>
    <li class="inherited"><a href="https://api.flutter.dev/flutter/dart-core/Object/hashCode.html">hashCode</a></li>
    <li><a href="../../wialon/WialonSdk/host.html">host</a></li>
    <li class="inherited"><a href="https://api.flutter.dev/flutter/dart-core/Object/runtimeType.html">runtimeType</a></li>
    <li><a href="../../wialon/WialonSdk/sessionId.html">sessionId</a></li>

    <li class="section-title"><a href="../../wialon/WialonSdk-class.html#instance-methods">Methods</a></li>
    <li><a href="../../wialon/WialonSdk/call.html">call</a></li>
    <li><a href="../../wialon/WialonSdk/log.html">log</a></li>
    <li><a href="../../wialon/WialonSdk/logout.html">logout</a></li>
    <li class="inherited"><a href="https://api.flutter.dev/flutter/dart-core/Object/noSuchMethod.html">noSuchMethod</a></li>
    <li><a href="../../wialon/WialonSdk/oauthLogin.html">oauthLogin</a></li>
    <li><a href="../../wialon/WialonSdk/reverseGeocoding.html">reverseGeocoding</a></li>
    <li><a href="../../wialon/WialonSdk/tokenLogin.html">tokenLogin</a></li>
    <li class="inherited"><a href="https://api.flutter.dev/flutter/dart-core/Object/toString.html">toString</a></li>

    <li class="section-title inherited"><a href="../../wialon/WialonSdk-class.html#operators">Operators</a></li>
    <li class="inherited"><a href="https://api.flutter.dev/flutter/dart-core/Object/operator_equals.html">operator ==</a></li>




</ol>

  </div><!--/.sidebar-offcanvas-->

  <div id="dartdoc-sidebar-right" class="sidebar sidebar-offcanvas-right">
  </div><!--/.sidebar-offcanvas-->

</main>

<footer>
  <span class="no-break">
    wialon
      2.0.3
  </span>

  
</footer>



<script src="../../static-assets/highlight.pack.js?v1"></script>
<script src="../../static-assets/script.js?v1"></script>



</body>

</html>

